rci
vray_render_infos_roll
closeit
theTime

cfgfile= (getDir #plugcfg)+"\\vrayRenderInfoCfg.txt"
if (getfiles cfgfile).count == 0 then (
	print "no cfg file found! creating one!"
	createfile cfgfile
	fs=openfile cfgfile mode:"w"
	format "false" to:fs
	closeit=false
	close fs
	) else(
	fs =openfile cfgfile mode:"r"
	closeit=readexpr fs
	print ("closeit has been READ as " + closeit as string)
	close fs
	)

fn messager = (
cr=renderers.current
	if findstring (cr as string) "v_ray" != undefined do 
	(
	--callbacks.removescripts #preRender id:#Vray_Render_Infos
	--callbacks.removescripts #postRender id:#Vray_Render_Infos_destroyer
	theMsg=stringstream ""
	-- render final image BLOCK
	if cr.options_dontRenderImage then format "NOT Rendering final Image\n" to:theMsg 
		else format "Rendering final Image\n" to:theMsg 
	--AA Block
	format "AA Type : " to: theMsg
	case  cr.imagesampler_type of
								(	
								0:(format "Fixed \nSubdivs: %\n" cr.fixedRate_subdivs to:theMsg)
								1:(format "Adaptive QMC \nSubdivs: %/%\n" cr.twoLevel_baseSubdivs cr.twoLevel_fineSubdivs to:theMsg)
								2:(format "Adaptive Subdivision \nRates Min/Max: %/% - Threshold : %\n" cr.adaptiveSubdivision_minRate cr.adaptiveSubdivision_maxRate cr.adaptiveSubdivision_threshold to:theMsg)
								) 
	Format "Filter: %\n" (if cr.filter_on then "on" else "off") to:theMsg
	If cr.filter_on do 
	(
		kernelName=cr.filter_kernel as string
		format "Filter Type: %\n  " (substring kernelName 1 (kernelName.count-7)) to:theMsg
	)
	--GI Block
	if cr.gi_on do
	(
	format "GI is Active\n" to:theMsg
	if cr.gi_refractCaustics do format "Refractive Caustics are Active\n" to:theMsg
	if cr.gi_reflectCaustics do format "Reflective Caustics are Active\n" to:theMsg
	format "Primary GI Method / Mult:\n  " to:theMsg
	case cr.gi_primary_type of 
							(
							0:(
								Format "IRMap/% Min/Max:%/% HSubDs/Int.Samp:%/%\n" cr.gi_primary_multiplier cr.gi_irradmap_minRate cr.gi_irradmap_maxRate  cr.gi_irradmap_subdivs cr.gi_irradmap_interpSamples to:theMsg
								case cr.adv_irradmap_mode of 
									(
									0: (format "Single Frame Mode\n" to:theMsg)
									1: (format "Multiframe Incremental Mode\n" to:theMsg)
									2: (format "From File Mode\n" to:theMsg)
									3: (format "Add to current map Mode\n" to:theMsg)
									4: (format "Incremental add to current map Mode\n" to:theMsg)
									5: (format "Bucket Mode\n" to:theMsg)
									6: (format "Animation (Prepass) Mode\n" to:theMsg)
									7: (format "Animation (Rendering) Mode\n" to:theMsg)
									)
								if cr.adv_irradmap_dontDelete then format "Map set to be kept in memory\n" to:theMsg else format "Map set to be deleted from memory\n" to:theMsg
								if cr.adv_irradmap_autoSave then format "and auto-saved to file\n" to:theMsg else format "and not auto-saved to file\n" to:theMsg
								)
							1:(
								Format "PhotonMap/%\n" cr.gi_primary_multiplier to:theMsg
								if cr.photonMap_mode==0 then format "New Map mode\n" to:theMsg else format "From File Mode\n" to:theMsg
								if cr.photonMap_dontDelete then format "Map set to be kept in memory\n" to:theMsg else format "Map set to be deleted from memory\n" to:theMsg
								if cr.photonMap_autoSave then format "and auto-saved to file\n" to:theMsg else format "and not auto-saved to file\n" to:theMsg
								)
							2:(Format "QMC/% SubDs:%\n" cr.gi_primary_multiplier cr.qmcgi_subdivs to:theMsg)
							3:(	case cr.lightcache_mode of (
								0: (Format "Single Frame LC/% SubDs:% SmpSz:%\n" cr.gi_primary_multiplier cr.lightcache_subdivs cr.lightcache_sampleSize to:theMsg)
								1: (Format "Fly-Through LC/% SubDs:% SmpSz:%\n" cr.gi_primary_multiplier cr.lightcache_subdivs cr.lightcache_sampleSize to:theMsg)
								2: (Format "From File LC/% SubDs:% SmpSz:%\n" cr.gi_primary_multiplier cr.lightcache_subdivs cr.lightcache_sampleSize to:theMsg)
								3: (Format "PPT/% SubDs:% SmpSz:%\n" cr.gi_primary_multiplier cr.lightcache_subdivs cr.lightcache_sampleSize to:theMsg)
								)
								if cr.lightcache_dontDelete then format "Map set to be kept in memory\n" to:theMsg else format "Map set to be deleted from memory\n" to:theMsg
								if cr.lightcache_autoSave then format "and auto-saved to file\n" to:theMsg else format "and not auto-saved to file\n" to:theMsg
								)
							)
	
	format "Secondary GI Method / Mult:\n  " to:theMsg
	case cr.gi_secondary_type of 
							(
							0:(Format "None / N/A\n" to:theMsg)
							1:(
								Format "PhotonMap / %\n" cr.gi_secondary_multiplier to:theMsg
								if cr.photonMap_mode==0 then format "New Map mode\n" to:theMsg else format "From File Mode\n" to:theMsg
								if cr.photonMap_dontDelete then format "Map set to be kept in memory\n" to:theMsg else format "Map set to be deleted from memory\n" to:theMsg
								if cr.photonMap_autoSave then format "and auto-saved to file\n" to:theMsg else format "and not auto-saved to file\n" to:theMsg
								)
							2:(Format "QMC/% SubDs:% Bounces:%\n" cr.gi_primary_multiplier cr.qmcgi_subdivs cr.qmcgi_depth to:theMsg)
							3:(		case cr.lightcache_mode of (
								0: (Format "Single Frame LC/% SubDs:% SmpSz:%\n" cr.gi_primary_multiplier cr.lightcache_subdivs cr.lightcache_sampleSize to:theMsg)
								1: (Format "Fly-Through LC/% SubDs:% SmpSz:%\n" cr.gi_primary_multiplier cr.lightcache_subdivs cr.lightcache_sampleSize to:theMsg)
								2: (Format "From File LC/% SubDs:% SmpSz:%\n" cr.gi_primary_multiplier cr.lightcache_subdivs cr.lightcache_sampleSize to:theMsg)
								3: (Format "PPT/% SubDs:% SmpSz:%\n" cr.gi_primary_multiplier cr.lightcache_subdivs cr.lightcache_sampleSize to:theMsg)
								)
								if cr.lightcache_dontDelete then format "Map set to be kept in memory\n" to:theMsg else format "Map set to be deleted from memory\n" to:theMsg
								if cr.lightcache_autoSave then format "and auto-saved to file\n" to:theMsg else format "and not auto-saved to file\n" to:theMsg
								)

								)
							
--Shadow Subdivs min/max
	format "Various scene infos:\n  " to:theMsg
	
	lightsArray = for i in lights where ((classOf i!=Targetobject and classof i!=vraysun and classof i !=Skylight))collect i
	if lightsArray.count !=0 do(
	LSbdArray =for i in lightsArray where ((classof i==VRayLight) or (classof i.shadowgenerator==VRayShadow) )collect i.subdivs
	sort LSbdArray
	avgShdSubd=0.0
	for i in LSbdArray do (
	avgShdSubd+= i as float/LSbdArray.count
	) 	
	format "Min/Max Shadow Subdivs:%/%\n  Average Shadow Subdivs:%\n" LSbdArray[1] LSbdArray[LSbdArray.count] avgShdSubd to:theMsg				
	)
	)
--Sun Infos
	sunsArray = for i in lights where (classof i==vraysun and classOf i!=Targetobject )collect i
	if sunsArray.count != 0 do(
	Yvector=[0,1,0]
	sunAngleCos=dot Yvector (sunsArray[1].pos/ length sunsArray[1].pos)
	thetime=12-(sunAngleCos*6)
	theSunSubdivs=sunsArray[1].shadow_subdivs
	format "Sun present:\n  Sun approximate time @ equator Hrs: %\n  Sun Shadow Subdivs: %\n" thetime theSunSubdivs to:theMsg
	)
--Material Subdivs min/max
	VRMatsArray=getclassinstances VRayMtl
	GReflSbdArray = for i in VRMatsArray where (i.reflection_glossiness <1.0) collect i.reflection_subdivs
	is_refl_interp=false
	refl_interp_min=1000
	refl_interp_max=-1000
	for i in VRMatsArray where i.reflection_useInterpolation==on do (
		is_refl_interp=true
		if 	i.reflect_minRate <= refl_interp_min do refl_interp_min=i.reflect_minRate
		if 	i.reflect_maxRate >= refl_interp_max do refl_interp_max=i.reflect_maxRate
		)
	GRefrSbdArray = for i in VRMatsArray where (i.refraction_glossiness <1.0) collect i.refraction_subdivs
	is_refr_interp=false
	refr_interp_min=1000
	refr_interp_max=-1000
	for i in VRMatsArray where i.refraction_useInterpolation==on do (
		is_refr_interp=true
		if 	i.refract_minRate <= refr_interp_min do refr_interp_min=i.refract_minRate
		if 	i.refract_maxRate >= refr_interp_max do refr_interp_max=i.refract_maxRate
		)
	sort GReflSbdArray 
 	sort GRefrSbdArray 
	if GReflSbdArray.count !=0 then (
	avgGReflSubd=0.0
	for i in GReflSbdArray do (
	avgGReflSubd+= i as float/GReflSbdArray.count
	) 	
		format "Min/Max Glossy Reflections Subdivs:%/%\n  Average Glossy Reflection Subdivs:%\n  " GReflSbdArray[1] GReflSbdArray[GReflSbdArray.count] avgGReflSubd to:theMsg
		if is_refl_interp do (format "there is at least one interpolated reflection\n  amongst the materials with \n  min rate=% and max rate=%\n" refl_interp_min refl_interp_max to:theMsg) 
		) else(
		format "No Glossy Reflections in the scene\n  " to:theMsg
		)
	if GRefrSbdArray.count !=0 then (
	avgGRefrSubd=0.0
	for i in GRefrSbdArray do (
	avgGRefrSubd+= i as float/GRefrSbdArray.count
	) 	
		format "Min/Max Glossy Refractions Subdivs:%/%\n  Average Glossy Reflection Subdivs:%\n  " GRefrSbdArray[1] GRefrSbdArray[GRefrSbdArray.count] avgGRefrSubd to:theMsg
		if is_refr_interp do (format "there is at least one interpolated refraction\n  amongst the materials with \n  min rate=% and max rate=%\n" refr_interp_min refr_interp_max to:theMsg ) 

		) else(
		format "No Glossy Refractions in the scene\n  " to:theMsg
		)
--Adaptive Rollout Creation Block
	global heightMultiplier =1
	seek theMsg 0
	while not (eof theMsg) do 
		(
		readline theMsg
		heightMultiplier +=1
		)
	newsize=(16*heightMultiplier)
	rci=rolloutCreator "vray_render_infos_roll" "VRay RenderTime Infos 1.2" --paramStr:("width:400 height:"+(newsize+32) as string)
	rci.begin()
	rci.addControl #label #lbl1 "Label" paramStr:("pos:[16,24] width:232 height:"+ newsize as string)
	rci.addControl #GroupBox #grp1 "VRay Render Infos" paramStr:("pos:[8,8] width:240 height:"+ (newsize+24)as string)
	rci.addControl #checkbox #chk1 "Close at render end" paramStr: ("checked:closeit")
	rci.addControl #timer #tmr1 "theClock"  paramStr: " active:false"
	rci.addHandler #chk1 #changed paramStr:"val" codeStr:" closeIt=chk1.state\n fs=openfile cfgfile mode:\"w\"\n format \"%\" closeit to:fs\n close fs\n print closeit as string"
	rci.addHandler #tmr1 #tick paramstr:"" codeStr:"theTime=tmr1.ticks\n if (theTime>=3 and closeit )do destroyDialog vray_render_infos_roll\n if closeit do print (3-theTime) as string "
	createdialog (rci.end())
	vray_render_infos_roll.lbl1.text = theMsg
	vray_render_infos_roll.width = 256
		
--Various MEssages and routines
	)-- ideal end of function if vray is current renderer
)--actual end of the messager() function

fn dialogDestroyer = (
if closeit do(
vray_render_infos_roll.tmr1.active=true
)
)

/*rollout vray_render_infos_roll "VRay RenderTime Infos" width:240 
(
	label lbl1 "Label" pos:[16,32] width:208 height:16
	GroupBox grp1 "VRay Render Infos" pos:[8,8] width:224 height:16 enabled:true
	on vray_render_infos_roll open do(
	messager()
	)
)	*/
callbacks.addscript #preRender "messager()" id:#Vray_Render_Infos
callbacks.addscript #postRender "dialogDestroyer()" id:#Vray_Render_Infos_destroyer
